<?php
//
// applet.php
//
// Module for displaying images through a Java applet viewer
//
// CopyRight (c) 2004-2010 RainbowFish Software / IMAGE Information Systems Ltd.
//
if (!session_id())
    session_start();

include_once "locale.php";
include_once "utils.php";

function appletExists() {
    $dir = dirname($_SERVER['SCRIPT_FILENAME']);
    $dir .= "/iQ-X/iQX.cab";
    return file_exists($dir);
}

function GetServerLogLevel() {
    $returnOutput = array();
    $returnstr = "";
    session_start();
    $database = $_SESSION['authenticatedDatabase'];
    session_write_close();
    $directory = dirname($_SERVER['SCRIPT_FILENAME']);
    $srvadmin = "\"" . $directory . "/srvadmin.exe\" -regget " . $database;
    $returnval = 1;
    exec($srvadmin, $returnOutput, $returnval);
    if ($returnval == 0) {
        // read status from ini file
        $loginfo = dirname($_SERVER['SCRIPT_FILENAME']);
        $loginfo .= "/LogInfo";
        if (!$handle = fopen($loginfo, "rt")) {
            return "False";
        }
        // read
        $buffer = fread($handle, 1024);
        $returnstr = $buffer;
        fclose($handle);
    } else {
        return "False";
    }
    return $returnstr;
}

function appletLicensed() {
    include_once "iqxInstallDialog.php";
    $appletLicense = "";
    if (!eregi("MSIE", $_SERVER['HTTP_USER_AGENT'])) {
        $appletLicense = "IE_required";
    } else if (!certificateExists()) {
        $appletLicense = "Certificate_required";
    } else if (!isset($_SESSION['iQX_licensed']) || (strcasecmp($_SESSION['iQX_licensed'], "1") != 0)) {
        // update license info and read out the update result file 'LicInfo.ini'
        $licgen = "\"" . dirname($_SERVER['SCRIPT_FILENAME']);
        $licgen .= "/licgen.exe\" -S";
        session_write_close();
        exec($licgen);
        $dir = dirname($_SERVER['SCRIPT_FILENAME']);
        $dir .= "/LicInfo.ini";
        $LicInfoFound = file_exists($dir);

        if (!$LicInfoFound) {
            $appletLicense = "License_error";
        } else {
            $ini_array = parse_ini_file($dir); // read ini file
            if ((strcmp($ini_array['Version'], "Trial") == 0) ||
                (strcmp($ini_array['Version'], "Extended Trial - 1Month") == 0) ||
                (strcmp($ini_array['Version'], "Extended Trial - 3Months") == 0) ||
                (strcmp($ini_array['Version'], "Distributor") == 0)) {
                if ($ini_array['DaysLeft'] > 0) {
                    $_SESSION['iQX_licensed'] = "1";
                    $appletLicense = "ok";
                } else {
                    $appletLicense = "License_expired";
                }
            } else if ((strcmp($ini_array['Version'], "Basic") == 0) || (strcmp($ini_array['Version'], "Pro") == 0)) {
                $_SESSION['iQX_licensed'] = "1";
                $appletLicense = "ok";
            } else if (strcmp($ini_array['Version'], "WebLicense") == 0) {
                $_SESSION['iQX_licensed'] = "1";
                $appletLicense = "weblicense";
            } else {
                $appletLicense = "unknown_error";
            }
            if (!isset($_SESSION['iQX_fingerprint']) || (strlen($_SESSION['iQX_fingerprint']) <> 9)) {
                if (strlen($ini_array['Fingerprint']) == 9) {
                    $_SESSION['iQX_fingerprint'] = $ini_array['Fingerprint'];
                }
            }
            if (!isset($_SESSION['iQWEB_loglevel']) || (strlen($_SESSION['iQWEB_loglevel']) <= 0)) {
                // log settings
                $logLevel = "";
                $logLevel = GetServerLogLevel();
                if (strlen($logLevel) > 0) {
                    $_SESSION['iQWEB_loglevel'] = $logLevel;
                }
            }
        }
    } else
        $appletLicense = "ok";
    return $appletLicense;
}
//
// uids - array of SOP instance UIDs to display
//
function appletViewer(&$uids) {
    print "<html>\n";
    print "<body style=\"margin: 0px;\" onload=\"window.focus();\">\n";
    require_once "header.php";
    print "</td></tr></table>";
    $alias = "";
    $scheme = (isset($_SERVER['HTTPS']) && !strcasecmp($_SERVER['HTTPS'], 'on'))?
        "https://" : "http://";
    $url = $scheme . $_SERVER['SERVER_NAME'] . ":" . $_SERVER["SERVER_PORT"];
    // dirname() function does not seem to work reliably, so use the following
    $tokens = explode("/", $_SERVER['PHP_SELF']);
    for ($i = 0; $i < count($tokens) - 1; $i++) {
        if (strlen($tokens[$i]))
            $alias = "/" . $tokens[$i];
    }
    
    $dbcon = new MyConnection();

    $showApplet = appletLicensed();
    
    if ((strlen($showApplet) > 0) && (strcasecmp($showApplet, "ok") == 0)) {
        // iQ-X certificate check and installation BOLs
		/*
        if (!certificateCheck()) {
            setcookie("iQX_certificate", 1, time()+60*60*24*356*2);
            certificateInstallWindow();
            die();
        } elseif (!pluginCheck()) {
            //setcookie("iQX_plugin", 1, time()+60*60*24*356*2);  # this cookie will be set in iQ-X
            pluginInstallWindow();
        }
		*/
        // iQ-X certificate check and installation EOLs

        $myImageUID = "";
        $mySeriesUID = "";
        $myStudyUID = "";
        $mySeriesDesc = "";
        $myStudyDesc = "";
        $myNumFrames = "";
        $myCompression = "";
        $numframes = "";
        $seriesuid = "";
        $studyuid = "";
        $seriesid = "";
        $studyid = "";
        $count = 0;

        $result = $dbcon->query("SELECT COUNT(*) FROM applentity WHERE rxcompression > 0");
        $row = $dbcon->fetch_row($result);
        if ($row[0] > 0)
            $myCompression = "true";
        else
            $myCompression = "false";

        foreach ($uids as $uid) {
            $result = $dbcon->query("SELECT image.seriesuid, image.numframes, series.studyuid, series.description, study.description, image.sopclass FROM image, series, study WHERE image.uuid=\"$uid\" AND image.seriesuid=series.uuid AND series.studyuid=study.uuid");
            $row = $dbcon->fetch_row($result);
            // checking for non-image SOP classes
            if (!getNonImageSopClassViewer($row[5])) {
                $seriesuid = $row[0];
                $numframes = $row[1];
                $studyuid = $row[2];
                $seriesid = $row[3];
                $studyid = $row[4];
                $count = $count + 1;
                $myImageUID = $myImageUID.$uid.'@#';
                $mySeriesUID = $mySeriesUID.$seriesuid.'@#';
                $myStudyUID = $myStudyUID.$studyuid.'@#';
                $mySeriesDesc = $mySeriesDesc.$seriesid.'@#';
                $myStudyDesc = $myStudyDesc.$studyid.'@#';
                $myNumFrames = $myNumFrames.$numframes.'@#';
            }
        }
        
         // checking and removing " or ' characters from the parameter values
        $replaceChar = array(
            "@\"@",
            "@'@",
        );
        $myImageUID = preg_replace($replaceChar, "", $myImageUID);
        $mySeriesUID = preg_replace($replaceChar, "", $mySeriesUID);
        $myStudyUID = preg_replace($replaceChar, "", $myStudyUID);
        $mySeriesDesc = preg_replace($replaceChar, "", $mySeriesDesc);
        $myStudyDesc = preg_replace($replaceChar, "", $myStudyDesc);
        $myNumFrames = preg_replace($replaceChar, "", $myNumFrames);
        
        // getting additional parameters
        // username
        $username = $dbcon->username;
        // create report privilege
        $cancreatereports = "false";
        if ($dbcon->isAdministrator($username)) {
            $cancreatereports = "true";
        } else {
            $reportResult = $dbcon->query("SELECT cancreatereports FROM iqxuserrights WHERE username=\"$username\"");
            if ($reportResult && ($dbcon->num_rows($reportResult) == 1)) {
                $rowReport = $dbcon->fetch_array($reportResult);
                if (isset($rowReport[0]) && ($rowReport[0] == 1))
                    $cancreatereports = "true";
                else
                    $cancreatereports = "false";
            }
        }
        // hardware fingerprint
        $fingerprint = "";
        if (isset($_SESSION['iQX_fingerprint']) && (strlen($_SESSION['iQX_fingerprint']) == 9)) {
            $fingerprint = $_SESSION['iQX_fingerprint'];
        }
        
        // database name
        $database = $dbcon->database;
        
        // log level
        $debugLog = "false";
        if (isset($_SESSION['iQWEB_loglevel']) && (strcasecmp($_SESSION['iQWEB_loglevel'], "Debug") == 0) ) {
            $debugLog = "true";
        }
        
        // full name
        $fullname = "";
        if (isset($_SESSION["fullname"]))
            $fullname = $_SESSION["fullname"];
        else
            $fullname = $username;
        
        if (strlen($myImageUID) > 0) {
            print "\n<OBJECT ID=\"iQX\" CODEBASE=\"$url$alias/iQ-X/iQX.cab#version=2,2,0,4\" height=\"93%\" width=\"100%\" CLASSID=\"clsid:DDBDACF6-CD47-46D9-AB27-5040F97BABDF\" type=\"application/x-oleobject\" standby=\"Loading iQ-X Plug-in...\">\n";
            
            print "<PARAM NAME=\"ServerURL\" VALUE=\"$url\">\n";
            print "<PARAM NAME=\"Alias\" VALUE=\"$alias\">\n";
            print "<PARAM NAME=\"Username\" VALUE=\"$fullname\">\n";
            print "<PARAM NAME=\"Login\" VALUE=\"$username\">\n";
            print "<PARAM NAME=\"CanCreateReports\" VALUE=\"$cancreatereports\">\n";
            print "<PARAM NAME=\"Fingerprint\" VALUE=\"$fingerprint\">\n";
            print "<PARAM NAME=\"ShowDebugLog\" VALUE=\"$debugLog\">\n";
            print "<PARAM NAME=\"Database\" VALUE=\"$database\">\n";
            print "<PARAM NAME=\"SID\" VALUE=\"" . session_id() . "\">\n";

            print "<PARAM NAME=\"LoadImageUID\" VALUE=\"$myImageUID\">\n";
            print "<PARAM NAME=\"LoadSeries\" VALUE=\"$mySeriesUID\">\n";
            print "<PARAM NAME=\"LoadStudy\" VALUE=\"$myStudyUID\">\n";
            print "<PARAM NAME=\"LoadDesc\" VALUE=\"$mySeriesDesc\">\n";
            print "<PARAM NAME=\"LoadDescStudy\" VALUE=\"$myStudyDesc\">\n";
            print "<PARAM NAME=\"SetImageCount\" VALUE=\"$count\">\n";
            print "<PARAM NAME=\"NumFrames\" VALUE=\"$myNumFrames\">\n";
            print "<PARAM NAME=\"Compression\" VALUE=\"$myCompression\">\n";
            print "</OBJECT>\n";
        } else {
            print "<h3><font color=red>";
            print pacsone_gettext("No images are available");
            print "</font></h3>";
        }
    }

    print "</body>\n";
    print "</html>\n";
}

?>